// extensions/common/mojom/url_pattern_set.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "extensions/common/mojom/url_pattern_set.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "extensions/common/mojom/url_pattern_set.mojom-params-data.h"
#include "extensions/common/mojom/url_pattern_set.mojom-shared-message-ids.h"

#include "extensions/common/mojom/url_pattern_set.mojom-import-headers.h"
#include "extensions/common/mojom/url_pattern_set.mojom-test-utils.h"


namespace extensions::mojom {
URLPattern::URLPattern()
    : valid_schemes(),
      pattern() {}

URLPattern::URLPattern(
    int32_t valid_schemes_in,
    const std::string& pattern_in)
    : valid_schemes(std::move(valid_schemes_in)),
      pattern(std::move(pattern_in)) {}

URLPattern::~URLPattern() = default;

void URLPattern::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "valid_schemes"), this->valid_schemes,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type int32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "pattern"), this->pattern,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::string&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool URLPattern::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
URLPatternSet::URLPatternSet()
    : patterns() {}

URLPatternSet::URLPatternSet(
    std::vector<::URLPattern> patterns_in)
    : patterns(std::move(patterns_in)) {}

URLPatternSet::~URLPatternSet() = default;

void URLPatternSet::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "patterns"), this->patterns,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<::URLPattern>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool URLPatternSet::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}


}  // extensions::mojom


namespace mojo {


// static
bool StructTraits<::extensions::mojom::URLPattern::DataView, ::extensions::mojom::URLPatternPtr>::Read(
    ::extensions::mojom::URLPattern::DataView input,
    ::extensions::mojom::URLPatternPtr* output) {
  bool success = true;
  ::extensions::mojom::URLPatternPtr result(::extensions::mojom::URLPattern::New());
  
      if (success)
        result->valid_schemes = input.valid_schemes();
      if (success && !input.ReadPattern(&result->pattern))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::extensions::mojom::URLPatternSet::DataView, ::extensions::mojom::URLPatternSetPtr>::Read(
    ::extensions::mojom::URLPatternSet::DataView input,
    ::extensions::mojom::URLPatternSetPtr* output) {
  bool success = true;
  ::extensions::mojom::URLPatternSetPtr result(::extensions::mojom::URLPatternSet::New());
  
      if (success && !input.ReadPatterns(&result->patterns))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace extensions::mojom {




}  // extensions::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif