// third_party/blink/public/mojom/messaging/static_bitmap_image.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_MESSAGING_STATIC_BITMAP_IMAGE_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_MESSAGING_STATIC_BITMAP_IMAGE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/messaging/static_bitmap_image.mojom-shared-internal.h"
#include "skia/public/mojom/bitmap.mojom-shared.h"
#include "gpu/ipc/common/mailbox_holder.mojom-shared.h"
#include "gpu/ipc/common/sync_token.mojom-shared.h"
#include "skia/public/mojom/image_info.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"


#include "base/component_export.h"




namespace blink::mojom {
class AcceleratedStaticBitmapImageDataView;

class SerializedStaticBitmapImageDataView;


}  // blink::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::AcceleratedStaticBitmapImageDataView> {
  using Data = ::blink::mojom::internal::AcceleratedStaticBitmapImage_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::SerializedStaticBitmapImageDataView> {
  using Data = ::blink::mojom::internal::SerializedStaticBitmapImage_Data;
  using DataAsArrayElement = Data;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kUnion;
};

}  // namespace internal
}  // namespace mojo


namespace blink::mojom {
// Interface base classes. They are used for type safety check.
class ImageReleaseCallbackInterfaceBase {};

using ImageReleaseCallbackPtrDataView =
    mojo::InterfacePtrDataView<ImageReleaseCallbackInterfaceBase>;
using ImageReleaseCallbackRequestDataView =
    mojo::InterfaceRequestDataView<ImageReleaseCallbackInterfaceBase>;
using ImageReleaseCallbackAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ImageReleaseCallbackInterfaceBase>;
using ImageReleaseCallbackAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ImageReleaseCallbackInterfaceBase>;


class AcceleratedStaticBitmapImageDataView {
 public:
  AcceleratedStaticBitmapImageDataView() = default;

  AcceleratedStaticBitmapImageDataView(
      internal::AcceleratedStaticBitmapImage_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetMailboxHolderDataView(
      ::gpu::mojom::MailboxHolderDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadMailboxHolder(UserType* output) {
    
    auto* pointer = data_->mailbox_holder.Get();
    return mojo::internal::Deserialize<::gpu::mojom::MailboxHolderDataView>(
        pointer, output, message_);
  }
  uint32_t usage() const {
    return data_->usage;
  }
  inline void GetImageInfoDataView(
      ::skia::mojom::ImageInfoDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadImageInfo(UserType* output) {
    
    auto* pointer = data_->image_info.Get();
    return mojo::internal::Deserialize<::skia::mojom::ImageInfoDataView>(
        pointer, output, message_);
  }
  bool is_origin_top_left() const {
    return data_->is_origin_top_left;
  }
  bool supports_display_compositing() const {
    return data_->supports_display_compositing;
  }
  bool is_overlay_candidate() const {
    return data_->is_overlay_candidate;
  }
  template <typename UserType>
  UserType TakeReleaseCallback() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<mojo::InterfacePtrDataView<::blink::mojom::ImageReleaseCallbackInterfaceBase>>(
            &data_->release_callback, &result, message_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::AcceleratedStaticBitmapImage_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class SerializedStaticBitmapImageDataView {
 public:
  using Tag = internal::SerializedStaticBitmapImage_Data::SerializedStaticBitmapImage_Tag;

  SerializedStaticBitmapImageDataView() = default;

  SerializedStaticBitmapImageDataView(
      internal::SerializedStaticBitmapImage_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const {
    // For inlined unions, |data_| is always non-null. In that case we need to
    // check |data_->is_null()|.
    return !data_ || data_->is_null();
  }

  Tag tag() const { return data_->tag; }
  bool is_bitmap() const { return data_->tag == Tag::kBitmap; }
  inline void GetBitmapDataView(
      ::skia::mojom::BitmapN32DataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadBitmap(UserType* output) const {
    
    CHECK(is_bitmap());
    return mojo::internal::Deserialize<::skia::mojom::BitmapN32DataView>(
        data_->data.f_bitmap.Get(), output, message_);
  }
  bool is_accelerated_image() const { return data_->tag == Tag::kAcceleratedImage; }
  inline void GetAcceleratedImageDataView(
      AcceleratedStaticBitmapImageDataView* output) const;

  template <typename UserType>
  [[nodiscard]] bool ReadAcceleratedImage(UserType* output) const {
    
    CHECK(is_accelerated_image());
    return mojo::internal::Deserialize<::blink::mojom::AcceleratedStaticBitmapImageDataView>(
        data_->data.f_accelerated_image.Get(), output, message_);
  }

 private:
  internal::SerializedStaticBitmapImage_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // blink::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::AcceleratedStaticBitmapImageDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::AcceleratedStaticBitmapImageDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::AcceleratedStaticBitmapImage_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::mailbox_holder(input)) in_mailbox_holder = Traits::mailbox_holder(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->mailbox_holder)::BaseType> mailbox_holder_fragment(
            fragment.message());
    mojo::internal::Serialize<::gpu::mojom::MailboxHolderDataView>(
        in_mailbox_holder, mailbox_holder_fragment);
    fragment->mailbox_holder.Set(
        mailbox_holder_fragment.is_null() ? nullptr : mailbox_holder_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->mailbox_holder.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null mailbox_holder in AcceleratedStaticBitmapImage struct");
    fragment->usage = Traits::usage(input);
    decltype(Traits::image_info(input)) in_image_info = Traits::image_info(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->image_info)::BaseType> image_info_fragment(
            fragment.message());
    mojo::internal::Serialize<::skia::mojom::ImageInfoDataView>(
        in_image_info, image_info_fragment);
    fragment->image_info.Set(
        image_info_fragment.is_null() ? nullptr : image_info_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->image_info.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null image_info in AcceleratedStaticBitmapImage struct");
    fragment->is_origin_top_left = Traits::is_origin_top_left(input);
    fragment->supports_display_compositing = Traits::supports_display_compositing(input);
    fragment->is_overlay_candidate = Traits::is_overlay_candidate(input);
    decltype(Traits::release_callback(input)) in_release_callback = Traits::release_callback(input);
    mojo::internal::Serialize<mojo::InterfacePtrDataView<::blink::mojom::ImageReleaseCallbackInterfaceBase>>(
        in_release_callback, &fragment->release_callback, &fragment.message());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid(fragment->release_callback),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
        "invalid release_callback in AcceleratedStaticBitmapImage struct");
  }

  static bool Deserialize(::blink::mojom::internal::AcceleratedStaticBitmapImage_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::AcceleratedStaticBitmapImageDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::SerializedStaticBitmapImageDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = UnionTraits<::blink::mojom::SerializedStaticBitmapImageDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        MessageFragment<::blink::mojom::internal::SerializedStaticBitmapImage_Data>& fragment,
                        bool inlined) {
    if (CallIsNullIfExists<Traits>(input)) {
       if (inlined)
        fragment->set_null();
      return;
    }

    if (!inlined)
      fragment.Allocate();

    // TODO(azani): Handle unknown and objects.
    // Set the not-null flag.
    fragment->size = kUnionDataSize;
    fragment->tag = Traits::GetTag(input);
    switch (fragment->tag) {
      case ::blink::mojom::SerializedStaticBitmapImageDataView::Tag::kBitmap: {
        decltype(Traits::bitmap(input))
            in_bitmap = Traits::bitmap(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_bitmap)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::skia::mojom::BitmapN32DataView>(
            in_bitmap, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null bitmap in SerializedStaticBitmapImage union");
        fragment->data.f_bitmap.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
      case ::blink::mojom::SerializedStaticBitmapImageDataView::Tag::kAcceleratedImage: {
        decltype(Traits::accelerated_image(input))
            in_accelerated_image = Traits::accelerated_image(input);
        mojo::internal::MessageFragment<
            typename decltype(fragment->data.f_accelerated_image)::BaseType>
            value_fragment(fragment.message());
        mojo::internal::Serialize<::blink::mojom::AcceleratedStaticBitmapImageDataView>(
            in_accelerated_image, value_fragment);
        MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
            value_fragment.is_null(),
            mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
            "null accelerated_image in SerializedStaticBitmapImage union");
        fragment->data.f_accelerated_image.Set(
            value_fragment.is_null() ? nullptr : value_fragment.data());
        break;
      }
    }
  }

  static bool Deserialize(::blink::mojom::internal::SerializedStaticBitmapImage_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input || input->is_null())
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::SerializedStaticBitmapImageDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink::mojom {

inline void AcceleratedStaticBitmapImageDataView::GetMailboxHolderDataView(
    ::gpu::mojom::MailboxHolderDataView* output) {
  auto pointer = data_->mailbox_holder.Get();
  *output = ::gpu::mojom::MailboxHolderDataView(pointer, message_);
}
inline void AcceleratedStaticBitmapImageDataView::GetImageInfoDataView(
    ::skia::mojom::ImageInfoDataView* output) {
  auto pointer = data_->image_info.Get();
  *output = ::skia::mojom::ImageInfoDataView(pointer, message_);
}


inline void SerializedStaticBitmapImageDataView::GetBitmapDataView(
    ::skia::mojom::BitmapN32DataView* output) const {
  CHECK(is_bitmap());
  *output = ::skia::mojom::BitmapN32DataView(data_->data.f_bitmap.Get(), message_);
}
inline void SerializedStaticBitmapImageDataView::GetAcceleratedImageDataView(
    AcceleratedStaticBitmapImageDataView* output) const {
  CHECK(is_accelerated_image());
  *output = AcceleratedStaticBitmapImageDataView(data_->data.f_accelerated_image.Get(), message_);
}


}  // blink::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_MESSAGING_STATIC_BITMAP_IMAGE_MOJOM_SHARED_H_